import javax.sound.sampled.*;
import java.net.URL;

class SoundPrims  extends Primitives {

  static String[] primlist={
    "loadsound", "1", "playsound", "2"
  };

  public String[] primlist(){return primlist;}

  public Object dispatch(int offset, Object[] args, LContext lc){
    switch(offset){
    case 0: return prim_loadsound(args[0],  lc);
    case 1: return prim_playsound(args[0], args[1], lc);
       }
    return null;
  }

  Object prim_loadsound(Object arg1,LContext lc){
    String file = Logo.aString(arg1, lc);
    try {
      URL url = SpriteFrame.class.getResource("sounds/" + file);
      AudioInputStream stream = AudioSystem.getAudioInputStream(url);
      AudioFormat format = stream.getFormat();
      DataLine.Info info = new DataLine.Info(Clip.class,
                                             format,
                                             ((int)stream.getFrameLength() *
                                              format.getFrameSize()));
      Clip clip = (Clip)AudioSystem.getLine(info);
      clip.open(stream);
      return clip;
      } catch (Exception e) { e.printStackTrace();}
      return "";
  }

  Object prim_playsound(Object arg1, Object arg2, LContext lc){
     Clip clip = (Clip)arg1;
     double volume = Logo.aDouble(arg2, lc);
     FloatControl gainControl = (FloatControl)clip.getControl(FloatControl.Type.MASTER_GAIN);
     float dB = (float)(Math.log(volume==0.0?0.0001:volume)/Math.log(10.0)*20.0);
     gainControl.setValue(dB);
     clip.setFramePosition(0);
     clip.start();
     return null;
  }


}



