import java.net.Socket;
import java.io.InputStream;
import java.io.BufferedInputStream;
import java.io.OutputStream;
import java.net.URLEncoder;

class TCPPrims extends Primitives {

  static String[] primlist={
    "connect", "2", "tcprecv", "0", "tcprecvn", "1", "tcpsend", "1", "tcptimeout", "1", "urlencode", "1", "tcpclose", "0"
  };

  public String[] primlist(){return primlist;}

  public Object dispatch(int offset, Object[] args, LContext lc){
    switch(offset){
    case 0: return prim_connect(args[0], args[1], lc);
    case 1: return prim_tcprecv(lc);
    case 2: return prim_tcprecvn(args[0], lc);
    case 3: return prim_tcpsend(args[0], lc);
    case 4: return prim_tcptimeout(args[0], lc);
    case 5: return prim_urlencode(args[0], lc);
    case 6: return prim_tcpclose(lc);
 }
    return null;
  }

	static Sock sock;

  Object prim_connect(Object arg1, Object arg2, LContext lc){
    try{sock = new Sock(Logo.aString(arg1, lc), Logo.anInt(arg2, lc));
    		sock.sock.setSendBufferSize(1048576);}
    catch (Exception e) {Logo.error("connect error: " + e, lc);}
    return null;
  }

  Object prim_tcprecv(LContext lc){
    try{return new Double(sock.sockin.read());}
    catch (Exception e) {Logo.error("tcprecv error: " + e, lc);}
    return null;
  }

  Object prim_tcprecvn(Object arg1, LContext lc){
    int len = Logo.anInt(arg1,lc), off=0;
    byte[] buf = new byte[len];
    try {
			while(len>0){
				int nread=sock.sockin.read(buf,off,len);
				len-=nread;off+=nread;}}
    catch (Exception e) {Logo.error("tcprecv error: " + e, lc);}
    return buf;
  }

  Object prim_tcpsend(Object arg1, LContext lc){
    try{
				if(arg1 instanceof byte[]) sock.sockout.write((byte[])arg1);
				else sock.sockout.write(Logo.anInt(arg1, lc));
        sock.sockout.flush();}
    catch (Exception e) {Logo.error("tcpsend error: " + e, lc);}
    return null;
  }

  Object prim_tcptimeout(Object arg1, LContext lc){
    int to = Logo.anInt(arg1,lc);
    try{sock.sock.setSoTimeout(to);}
    catch (Exception e) {Logo.error("tcptimeout error: " + e, lc);}
    return null;
  }

  Object prim_urlencode(Object arg1, LContext lc){
    try{return URLEncoder.encode(Logo.prs(arg1), "UTF-8");}
    catch (Exception e) {Logo.error("urlencode error: " + e, lc);}
    return null;
  }

	Object prim_tcpclose(LContext lc){
    try{
			sock.sock.close();
			sock = null;
		}
    catch (Exception e) {Logo.error("tcpsend error: " + e, lc);}
    return null;
	}

}

class Sock {
  Socket sock;
  InputStream sockin;
  OutputStream sockout;

  Sock(String addr, int port) throws Exception{
    sock = new Socket(addr, port);
    sockin = new BufferedInputStream(sock.getInputStream());
    sockout = sock.getOutputStream();
  }

}
